package VistaControlador;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.time.LocalDate;
import java.util.Date;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import com.github.lgooddatepicker.components.DatePicker;

import Logica.Gestion;
import Logica.Meses;

public class VistaPanelLateral extends JPanel{
	protected JTextArea total;
	protected JTextArea gastoEnvio;
	protected static DatePicker elegirMes = inicializarCalendario();
	protected JButton mostrarEstadisticas;
	JButton aniadirGestion;
	JButton eliminarTransaccion;
	Meses meses;
	/**
	 * Constructor del panel lateral que gestiona las pestanias
	 * 
	 * @param meses	datos a gestionar
	 */
	VistaPanelLateral(Meses meses){
		this.setPreferredSize(new Dimension(200,200));
		this.meses=meses;
		this.total = new JTextArea(String.valueOf(meses.getTotal()));
		this.gastoEnvio = new JTextArea();
		this.mostrarEstadisticas = new JButton("Mostrar grafico del mes");
		this.aniadirGestion = new JButton("Aniadir nueva gestión");
		this.add(this.mostrarEstadisticas);
		this.add(VistaPanelLateral.elegirMes);
		this.add(this.total);
		this.add(this.gastoEnvio);
		this.add(this.aniadirGestion);
		this.eliminarTransaccion = new JButton("Eliminar Deseleccionados");
		this.add(this.eliminarTransaccion);
	}
	
	/**
	 * Actualiza los datos que se deben mostrar
	 */
	void actualizarDatos(Gestion gestion) {
		this.total.setText("Total: " + String.valueOf(this.meses.getTotal()) + "€");
		this.gastoEnvio.setText("Suma: " + String.valueOf(gestion.getSuma()) + "€");
	}
	
	/**
	 * devuelve la fecha en la que se encuentra
	 * 
	 * @return	fecha en la que se encuentra
	 */
	static LocalDate getDate() {
		return elegirMes.getDate();
	}
	
	/**
	 * Inicializa el calendario
	 * 
	 * @return calendario que inicializa
	 */
	static DatePicker inicializarCalendario() {
		DatePicker ret = new DatePicker();
		ret.setDate(LocalDate.now());
		return ret;
	}
	
}
